<?php
require(dirname(__FILE__) . '/lib/paystarconfig.php');
$nzshpcrt_gateways[$num]['name'] = 'paystar';
$nzshpcrt_gateways[$num]['internalname'] = 'paystar';
$nzshpcrt_gateways[$num]['function'] = 'gateway_paystar';
$nzshpcrt_gateways[$num]['form'] = "form_paystar";
$nzshpcrt_gateways[$num]['submit_function'] = "submit_paystar";
$nzshpcrt_gateways[$num]['payment_type'] = "credit_card";
$nzshpcrt_gateways[$num]['display_name'] = $ws_config['name'];
$nzshpcrt_gateways[$num]['image'] = ''; //WPSC_URL . '/images/1.png';

function gateway_paystar($separator, $sessionid)
{
	global $wpdb;
	$purchase_log_sql = $wpdb->prepare( "SELECT * FROM `".WPSC_TABLE_PURCHASE_LOGS."` WHERE `sessionid`= %s LIMIT 1", $sessionid );
	$purchase_log = $wpdb->get_results($purchase_log_sql,ARRAY_A) ;

	$cart_sql = "SELECT * FROM `".WPSC_TABLE_CART_CONTENTS."` WHERE `purchaseid`='".$purchase_log[0]['id']."'";
	$cart = $wpdb->get_results($cart_sql,ARRAY_A) ;

	$data['product_id'] = get_option('paystar_product_id');
	$data['product_name'] = get_option('paystar_product_name');
	$data['product_price_currency'] = get_option('paystar_curcode');
	$data['cb_url'] = add_query_arg( 'paystar_callback', 'true', home_url( '/' ) );
	$data['cb_type'] = 'P';
	
	$data['cs1'] = $sessionid;
	$data['cs2'] = 'paystar';

	// Get Currency details abd price
	$currency_code = $wpdb->get_results("SELECT `code` FROM `".WPSC_TABLE_CURRENCY_LIST."` WHERE `id`='".get_option('currency_type')."' LIMIT 1",ARRAY_A);
	$local_currency_code = $currency_code[0]['code'];
	$paystar_currency_code = get_option('paystar_curcode');

	// paystar only processes in the set currency.  This is USD or EUR dependent on what the Chornopay account is set up with.
	// This must match the paystar settings set up in wordpress.  Convert to the paystar currency and calculate total.
	$curr=new CURRENCYCONVERTER();
	$decimal_places = 2;
	$total_price = 0;

	$i = 1;

	$all_donations = true;
	$all_no_shipping = true;

	foreach($cart as $item)
	{
		$product_data = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM `" . $wpdb->posts . "` WHERE `id`= %d LIMIT 1", $item['prodid'] ), ARRAY_A );
		$product_data = $product_data[0];
		$variation_count = count($product_variations);

		//Does this even still work in 3.8? We're not using this table.
		$variation_sql = $wpdb->prepare( "SELECT * FROM `".WPSC_TABLE_CART_ITEM_VARIATIONS."` WHERE `cart_id` = %d", $item['id'] );
		$variation_data = $wpdb->get_results( $variation_sql, ARRAY_A );
		$variation_count = count($variation_data);

		if($variation_count >= 1)
      	{
      		$variation_list = " (";
      		$j = 0;

      		foreach($variation_data as $variation)
        	{
        		if($j > 0)
          		{
          			$variation_list .= ", ";
          		}
        		$value_id = $variation['venue_id'];
        		$value_data = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM `".WPSC_TABLE_VARIATION_VALUES."` WHERE `id`= %d LIMIT 1", $value_id ), ARRAY_A);
        		$variation_list .= $value_data[0]['name'];
        		$j++;
        	}
      		$variation_list .= ")";
      	}
      	else
        {
        	$variation_list = '';
        }

    	$local_currency_productprice = $item['price'];

			$local_currency_shipping = $item['pnp'];


			$paystar_currency_productprice = $local_currency_productprice;
			$paystar_currency_shipping = $local_currency_shipping;

    	$data['item_name_'.$i] = $product_data['name'].$variation_list;
    	$data['amount_'.$i] = number_format(sprintf("%01.2f", $paystar_currency_productprice),$decimal_places,'.','');
    	$data['quantity_'.$i] = $item['quantity'];
    	$data['item_number_'.$i] = $product_data['id'];

		if($item['donation'] !=1)
      	{
      		$all_donations = false;
      		$data['shipping_'.$i] = number_format($paystar_currency_shipping,$decimal_places,'.','');
      		$data['shipping2_'.$i] = number_format($paystar_currency_shipping,$decimal_places,'.','');
      	}
      	else
      	{
      		$data['shipping_'.$i] = number_format(0,$decimal_places,'.','');
      		$data['shipping2_'.$i] = number_format(0,$decimal_places,'.','');
      	}

    	if($product_data['no_shipping'] != 1) {
      		$all_no_shipping = false;
      	}


		$total_price = $total_price + ($data['amount_'.$i] * $data['quantity_'.$i]);

		if( $all_no_shipping != false )
			$total_price = $total_price + $data['shipping_'.$i] + $data['shipping2_'.$i];

    	$i++;
	}
  	$base_shipping = $purchase_log[0]['base_shipping'];
  	if(($base_shipping > 0) && ($all_donations == false) && ($all_no_shipping == false))
    {
		$data['handling_cart'] = number_format($base_shipping,$decimal_places,'.','');
		$total_price += number_format($base_shipping,$decimal_places,'.','');
    }

	$data['product_price'] = $total_price;


	if(WPSC_GATEWAY_DEBUG == true ) 
		die("<pre>".print_r($data,true)."</pre>");

	if ($data['product_price_currency'] == 'IRR')
		$data['product_price'] *= 10;

	$data['decline_url'] = get_option('transact_url') . '?paystar_callback=true&id=' . $sessionid . '&product_price=' . $data['product_price'];
	
	require(dirname(__FILE__) . '/lib/paystarconfig.php');
	$res = false;
	try 
	{
		$c = $_POST['collected_data'];
		$description = !empty($c[9]) ? "\nایمیل خریدار : {$c[9]}" : '';
		$description .= !empty($c[18]) ? "\nتلفن همراه خریدار : {$c[18]}" : '';

		$f = array(
			'amount' => $data['product_price'],
			'pin' => get_option('paystar_pin'),
			'callback' => $data['decline_url'],
			'bank' => get_option('paystar_bank'),
			'description' => $description
		);

		$f_ = '';
		foreach($f as $k=>$v) 
			$f_ .= $k . '=' . urlencode($v) . '&'; 
			
		rtrim($f_, '&');

		$ch = curl_init();
		curl_setopt($ch,CURLOPT_URL, "http://{$ws_config['address']}/api/create/");
		curl_setopt($ch,CURLOPT_POST, count($f));
		curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
		$res = curl_exec($ch);
		curl_close($ch);
	}
	catch(Exception $e) 
	{
		echo '<meta charset=utf-8><font color=red>اتصال به بانک برقرار نشد .</font>';
		die;
	}

	if(!$res) 
	{
		echo '<meta charset=utf-8><font color=red>اتصال به بانک برقرار نشد .</font>';
		die;		
	}
	else if(strlen($res) > 5)
	{
		header("Location: http://{$ws_config['address']}/paying/{$res}");
		exit;
	}	
	else
	{
		echo '<meta charset=utf-8><font color=red>' . $res . '</font>';
		die;		
	}						
  	exit;
}

function nzshpcrt_paystar_callback()
{
	global $wpdb;
	require(dirname(__FILE__) . '/lib/paystarconfig.php');
	
	// needs to execute on page start
	// look at page 36
	if(isset($_GET['paystar_callback']) && ($_GET['paystar_callback'] == 'true'))
	{
		if(isset($_REQUEST['id']))
		{
			$au = @$_POST['transid'];
			if(!empty($au))
			{
				$res = false;
				try
				{
					$f = array(
						'amount' => $_GET['product_price'],
						'pin' => get_option('paystar_pin'),
						'transid' => $au,
					);
					
					$f_ = '';
					foreach($f as $k=>$v) 
						$f_ .= $k . '=' . urlencode($v) . '&'; 
						
					rtrim($f_, '&');

					$ch = curl_init();
					curl_setopt($ch,CURLOPT_URL, "http://{$ws_config['address']}/api/verify/");
					curl_setopt($ch,CURLOPT_POST, count($f));
					curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
					curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
					$res = curl_exec($ch);
					curl_close($ch);
				}
				catch(Exception $e) 
				{
					$wpdb->update( WPSC_TABLE_PURCHASE_LOGS, array( 'transactid' => $au, 'date' => time() ), array( 'sessionid' => $sessionid ), array( '%d', '%s' ) );
				}

				$sessionid = trim(stripslashes($_REQUEST['id']));
				if(!empty($res) AND $res==1)
				{
					$data = array(
						'processed'  => 2,
						'transactid' => $au,
						'date'       => time(),
					);
					wpsc_update_purchase_log_details( $sessionid, $data, 'sessionid' );
					transaction_results($sessionid, false, $au);					
				}
				else
					$wpdb->update( WPSC_TABLE_PURCHASE_LOGS, array( 'transactid' => $au, 'date' => time() ), array( 'sessionid' => $sessionid ), array( '%d', '%s' ) );
			}
			else
				$wpdb->update( WPSC_TABLE_PURCHASE_LOGS, array( 'transactid' => $au, 'date' => time() ), array( 'sessionid' => $sessionid ), array( '%d', '%s' ) );
		}
		else
		{
			// Security Hash failed!!.. notify someone..
			$message = "This message has been sent because a call to your paystar function was made by a server that did not have the correct security key.  This could mean someone is trying to hack your payment site.  The details of the call are below.\n\r\n\r";
			$message .= "OUR_POST:\n\r".print_r($header . $req,true)."\n\r\n\r";
			$message .= "THEIR_POST:\n\r".print_r($_POST,true)."\n\r\n\r";
			$message .= "GET:\n\r".print_r($_GET,true)."\n\r\n\r";
			$message .= "SERVER:\n\r".print_r($_SERVER,true)."\n\r\n\r";
			mail(get_option('purch_log_email'), "paystar Security Key Failed!", $message);
		}

		// If in debug, email details
		if(get_option('paystar_debug') == 1)
		{
			$message = "This is a debugging message sent because it appears that you are in debug mode.\n\rEnsure paystar debug is turned off once you are happy with the function.\n\r\n\r";
			$message .= "OUR_POST:\n\r".print_r($header . $req,true)."\n\r\n\r";
			$message .= "THEIR_POST:\n\r".print_r($_POST,true)."\n\r\n\r";
			$message .= "GET:\n\r".print_r($_GET,true)."\n\r\n\r";
			$message .= "SERVER:\n\r".print_r($_SERVER,true)."\n\r\n\r";
			mail(get_option('purch_log_email'), "paystar Data", $message);
		}
	}
}

function submit_paystar()
{
	if(isset($_POST['paystar_product_id']))
    {
    	update_option('paystar_product_id', $_POST['paystar_product_id']);
    }

  	if(isset($_POST['paystar_product_name']))
    {
    	update_option('paystar_product_name', $_POST['paystar_product_name']);
    }

  	if(isset($_POST['paystar_curcode']))
    {
    	update_option('paystar_curcode', $_POST['paystar_curcode']);
    }

	if(isset($_POST['paystar_pin']))
	{
		update_option('paystar_pin', $_POST['paystar_pin']);
	}
	
	if(isset($_POST['paystar_bank']))
	{
		update_option('paystar_bank', $_POST['paystar_bank']);
	}


  	if(isset($_POST['paystar_debug']))
    {
    	update_option('paystar_debug', $_POST['paystar_debug']);
    }

    if (!isset($_POST['paystar_form'])) $_POST['paystar_form'] = array();
	foreach((array)$_POST['paystar_form'] as $form => $value)
    {
    	update_option(('paystar_form_'.$form), $value);
    }
	return true;
}

function form_paystar()
{
	require(dirname(__FILE__) . '/lib/paystarconfig.php');
	$xb = '';
	foreach($ws_config['bank'] as $k=>$v)
	{
		$sb = (get_option('paystar_bank') == $k) ? "selected='selected'" : '';
		$xb .= "<option value='{$k}'{$sb}>{$v}</option>\n";
	}
		
	$select_currency[get_option('paystar_curcode')] = "selected='selected'";
	$paystar_pin = ( get_option('paystar_pin')=='' ? 'xxxxx' : get_option('paystar_pin') );

	$paystar_debug = get_option('paystar_debug');
	$paystar_debug1 = "";
	$paystar_debug2 = "";
	switch($paystar_debug)
	{
		case 0:
			$paystar_debug2 = "checked ='checked'";
			break;
		case 1:
			$paystar_debug1 = "checked ='checked'";
			break;
	}

	if (!isset($select_currency['IRR'])) $select_currency['IRR'] = '';
	if (!isset($select_currency['IRT'])) $select_currency['IRT'] = '';

	$output = "
		<tr>
			<td>" . __( 'Product ID', 'wpsc' ) . "</td>
			<td>
				<input type='text' size='40' value='" . get_option( 'paystar_product_id' ) . "' name='paystar_product_id' />
				<p class='description'>
					" . __( 'This should be set to your product ID that has been set up in the paystar client interface. This is the paystar product that all purchases will be processed against. The cost will be changed depending on the grand total of the users cart.', 'wpsc' ) . "
				</p>
			</td>
		</tr>
		<tr>
			<td>" . __( 'Product Name', 'wpsc' ) . "</td>
			<td>
				<input type='text' size='40' value='" . get_option( 'paystar_product_name' ) . "' name='paystar_product_name' />
				<p class='description'>
					" . __( 'This is not important and is usually set to the name of the web shop. It is displayed on the paystar secure processing page.', 'wpsc' ) . "
				</p>
		</tr>
		<tr>
			<td>" . __( 'واحد پولی', 'wpsc' ) . "</td>
			<td>
				<select name='paystar_curcode'>
					<option " . $select_currency['IRR'] . " value='IRR'>ریال</option>
					<option " . $select_currency['IRT'] . " value='IRT'>تومان</option>
				</select>
				<p class='description'>
					" . __( 'واحد پولی خود را انتخاب کنید . همه پرداخت ها با این واحد تعیین میشوند .', 'wpsc' ) . "
				</p>
		</tr>
		<tr>
			<td>" . __( 'آدرس برگشت', 'wpsc' ) . "</td>
			<td>
				<input type='text' size='40' value='".get_option('transact_url')."' name='paystar_return_url' />
				<p class='description'>
					" . __( 'Enter this URL in the paystar web client against the Product ID that you have set up. This page is the transaction details page that you have configured in Shop Options.  It can not be edited on this page.', 'wpsc' ) . "
				</p>
		</tr>
		<tr>
			<td>شناسه درگاه</td>
			<td>
				<input type='text' size='40' value='" . $paystar_pin . "' name='paystar_pin' />
				<p class='description'>شناسه درگاه خود را وارد نمایید .</p>
		</tr>
		<tr>
			<td>" . __( 'بانک', 'wpsc' ) . "</td>
			<td>
				<select name='paystar_bank'>
					" . $xb . "
				</select>
				<p class='description'>
					" . __( 'بانک مورد نظر برای انجام تراکنش ها انتخاب شود .', 'wpsc' ) . "
				</p>
		</tr>
		<tr>
			<td>" . __( 'حالت اشکال یابی', 'wpsc' ) . "</td>
			<td>
				<input type='radio' value='1' name='paystar_debug' id='paystar_debug1' " . $paystar_debug1 . " /> <label for='paystar_debug1'>".__('بله', 'wpsc')."</label> &nbsp;
				<input type='radio' value='0' name='paystar_debug' id='paystar_debug2' " . $paystar_debug2 . " /> <label for='paystar_debug2'>".__('خیر', 'wpsc')."</label>
				<p class='description'>
					" . __( 'فقط برای تست ارتباط این گزینه را فعال نمایید در غیر این صورت باید همیشه غیرفعال باشد .', 'wpsc' ) . "
				</p>
		</tr>
		<tr class='firstrowth'>
			<td style='border-bottom: medium none;' colspan='2'>
				<strong class='form_group'>" . __( 'فرم ارسال به درگاه پرداخت', 'wpsc' ) . "</strong>
			</td>
		</tr>

		";

	return $output;
}

add_action('init', 'nzshpcrt_paystar_callback');
?>